//
//  DeviceEnumerator.h
//  BouncingBallWithOde
//

#ifndef __OpenNiMultiViewer__DeviceEnumerator__
#define __OpenNiMultiViewer__DeviceEnumerator__

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>
#include <XnCppWrapper.h>
#include <map>
#include <string>

class Device;
class Context;

class DeviceEnumerator : private boost::noncopyable
{
public:
        DeviceEnumerator();

        std::map<int, boost::shared_ptr<Device> >& get_devices()
        {
                return devices_;
        }
        void enumerate_production_trees(boost::shared_ptr<Context> context);
        void enumerate_existing_nodes(boost::shared_ptr<Context> context, const XnMapOutputMode& map_mode);
        
private:
        std::map<int, boost::shared_ptr<Device> > devices_;
        
        const std::string get_info_string(const xn::NodeInfo& info) const;
        void enumerate_production_trees(boost::shared_ptr<Context> context, XnProductionNodeType type);

};
#endif /* defined(__OpenNiMultiViewer__DeviceEnumerator__) */
